using System;

class main
{
  static void Main()
  {
    int i , j , q , x , y;
    var s = Console.ReadLine().Split();
    var n = int.Parse(s[0]);
    var m = int.Parse(s[1]);
    int[,] matrica = new int[n,m];
    for(i=0;i<n;i++){
        s = Console.ReadLine().Split();
        for(j=0;j<m;j++)
            matrica[i,j]=int.Parse(s[j]);
    }
    q = int.Parse(Console.ReadLine());
    int[] a = new int[q];
    for(i=0;i<q;i++){
        s = Console.ReadLine().Split();
        y = int.Parse(s[0]);
        x = int.Parse(s[1]);
        if(x!=1 && y!=1)
            a[i]=(m*(n*n+n+m- 1))/2;
        else if(x==1)
            a[i]=(m*((3*m) - (2*x) + (n*(n + 1)) - 1) + (2*x) - 2)/2;
        else
            a[i]=(m * (m + 2*y - 1 + n*(n + 1)) + 2*y)/2;
    }
    for(i=0;i<q;i++){
        Console.WriteLine(a[i]);
    }
  }
}